// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ForEachScreensaver.java

package org.jdesktop.jdic.screensaver.autogen;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.ExecTask;
import org.apache.tools.ant.types.Commandline;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

// Referenced classes of package org.jdesktop.jdic.screensaver.autogen:
//            HackConfigScanner, HackConfig, Utilities

public class ForEachScreensaver extends Task
{
    public static class LocalArg
    {

        public String getLine()
        {
            return line;
        }

        public void setLine(String line)
        {
            this.line = line;
        }

        private String line;

        public LocalArg()
        {
        }
    }

    public static class LocalExec extends Task
    {

        public void addArg(LocalArg arg)
        {
            args.add(arg);
        }

        public void setVariables(Properties variables)
        {
            this.variables = variables;
        }

        public File getDir()
        {
            return dir;
        }

        public void setDir(File dir)
        {
            this.dir = dir;
        }

        public String getExecutable()
        {
            return executable;
        }

        public void setExecutable(String executable)
        {
            this.executable = executable;
        }

        public boolean isFailonerror()
        {
            return failonerror;
        }

        public void setFailonerror(boolean failonerror)
        {
            this.failonerror = failonerror;
        }

        public void execute()
        {
            ExecTask execTask = (ExecTask)getProject().createTask("exec");
            execTask.setDir(dir);
            execTask.setExecutable(executable);
            execTask.setFailonerror(failonerror);
            for(int i = 0; i < args.size(); i++)
            {
                org.apache.tools.ant.types.Commandline.Argument arg = execTask.createArg();
                LocalArg localArg = (LocalArg)args.get(i);
                String line = localArg.getLine();
                line = replaceVars(line);
                arg.setLine(line);
            }

            execTask.init();
            execTask.execute();
        }

        private String replaceVars(String line)
        {
            for(Iterator iter = variables.keySet().iterator(); iter.hasNext();)
            {
                String var = (String)iter.next();
                String value = (String)variables.get(var);
                int index;
                while((index = line.indexOf(var)) != -1) 
                    line = line.substring(0, index) + value + line.substring(index + var.length());
            }

            return line;
        }

        private ArrayList args;
        private File dir;
        private String executable;
        private boolean failonerror;
        private Properties variables;

        public LocalExec()
        {
            args = new ArrayList();
            variables = new Properties();
        }
    }


    public ForEachScreensaver()
    {
        execs = new ArrayList();
    }

    public void setConfDir(File confDir)
    {
        this.confDir = confDir;
    }

    public File getConfDir()
    {
        return confDir;
    }

    public void setOutDir(File outDir)
    {
        this.outDir = outDir;
    }

    public File getOutDir()
    {
        return outDir;
    }

    public void addExec(LocalExec exec)
    {
        execs.add(exec);
    }

    public String getOs()
    {
        return os;
    }

    public void setOs(String os)
    {
        this.os = os;
    }

    public boolean isJogl()
    {
        return jogl;
    }

    public void setJogl(boolean jogl)
    {
        this.jogl = jogl;
    }

    public void execute()
        throws BuildException
    {
        if(confDir == null)
            throw new BuildException("confDir parameter is required.");
        if(outDir == null)
            throw new BuildException("outDir parameter is required.");
        if(!outDir.exists() || !outDir.isDirectory())
            throw new BuildException("outDir is not a directory or does not exist.");
        if(os == null)
            throw new BuildException("os parameter is required.");
        File confFiles[] = confDir.listFiles(new FilenameFilter() {

            public boolean accept(File dir, String filename)
            {
                return filename.endsWith(".xml") || filename.endsWith(".XML");
            }

        });
        Properties savers = new Properties();
        try
        {
            DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = builderFactory.newDocumentBuilder();
            for(int i = 0; i < confFiles.length; i++)
            {
                log("Processing " + confFiles[i].getName() + " for " + os + "...");
                Properties variables = new Properties();
                try
                {
                    InputStream in = new FileInputStream(confFiles[i]);
                    org.w3c.dom.Document document = builder.parse(new InputSource(in));
                    HackConfigScanner scanner = new HackConfigScanner(document);
                    scanner.visitDocument();
                    in.close();
                    HackConfig config = scanner.getHackConfig();
                    log("  - Command name: " + config.getName());
                    String exeName = config.getName() + "-bin";
                    variables.setProperty("[[exe]]", exeName);
                    String jarArg = null;
                    String classArg = null;
                    ArrayList options = config.getOptions();
                    for(int j = 0; j < options.size(); j++)
                    {
                        HackConfig.Option opt = (HackConfig.Option)options.get(j);
                        if(!(opt instanceof HackConfig.CommandOption))
                            continue;
                        HackConfig.CommandOption cmd = (HackConfig.CommandOption)opt;
                        String arg = cmd.getArg();
                        if(arg.startsWith("-jar "))
                        {
                            jarArg = arg.substring(5);
                            continue;
                        }
                        if(arg.startsWith("-class "))
                            classArg = arg.substring(7);
                    }

                    if(jarArg == null)
                        throw new BuildException("Error: " + confFiles[i] + " has no command with " + "-jar argument");
                    log("  - JAR: " + jarArg);
                    if(classArg == null)
                        throw new BuildException("Error: " + confFiles[i] + " has no command with " + "-class argument");
                    log("  - Class: " + classArg);
                    String filename = confFiles[i].getName();
                    int index = filename.lastIndexOf('.');
                    variables.setProperty("[[source]]", filename.substring(0, index));
                    filename = filename.substring(0, index);
                    if(os.equals("unix"))
                    {
                        generateUnixShellWrapper(outDir, filename, jarArg, classArg, exeName);
                        generateUnixSource(outDir, filename, jarArg, classArg, config.getName(), options);
                        savers.setProperty(filename, exeName);
                    } else
                    if(os.equals("win32"))
                        generateWindowsExecutable(outDir, filename, jarArg, classArg, config.getName(), confFiles[i]);
                }
                catch(IOException e)
                {
                    throw new BuildException(e);
                }
                catch(SAXException e)
                {
                    throw new BuildException(e);
                }
                for(int j = 0; j < execs.size(); j++)
                {
                    LocalExec t = (LocalExec)execs.get(j);
                    t.setVariables(variables);
                    t.execute();
                }

            }

            if(os.equals("unix"))
                generateUnixMakefile(outDir, savers);
        }
        catch(ParserConfigurationException e)
        {
            throw new BuildException(e);
        }
        catch(IOException e)
        {
            throw new BuildException(e);
        }
    }

    private void generateUnixShellWrapper(File outDir, String filename, String jarArg, String classArg, String exeName)
        throws IOException
    {
        File outFile = new File(outDir, filename);
        Properties substitute = new Properties();
        substitute.setProperty("jar", jarArg);
        substitute.setProperty("class", classArg);
        substitute.setProperty("exe", exeName);
        Utilities.copyFileAndSubstitute(outFile, "/org/jdesktop/jdic/screensaver/autogen/resources/unix/saverbeans.sh.template", substitute, "[[", "]]", false);
    }

    private void generateUnixMakefile(File outDir, Properties savers)
        throws IOException
    {
        File outFile = new File(outDir, "Makefile");
        Properties substitute = new Properties();
        StringBuffer targets = new StringBuffer();
        Iterator iter = savers.keySet().iterator();
        StringBuffer exes = new StringBuffer();
        for(; iter.hasNext(); exes.append(' '))
        {
            String key = (String)iter.next();
            String value = savers.getProperty(key);
            exes.append(value);
        }

        substitute.setProperty("exes", exes.toString());
        String all = exes.toString();
        if(jogl)
            all = all + " linkjogl";
        substitute.setProperty("all", all);
        String key;
        String value;
        for(iter = savers.keySet().iterator(); iter.hasNext(); targets.append("\t${cc} ${ccargs} -o " + key + ".o " + key + ".c\n" + "\t${link} ${linkargs} -o " + value + " " + key + ".o ${linkobj}\n" + "\t${strip} " + value + "\n" + "\tchmod a+x " + key + "\n\n"))
        {
            key = (String)iter.next();
            value = savers.getProperty(key);
            targets.append(value + ":\n");
        }

        if(jogl)
            targets.append("linkjogl:\n").append("\t@if [ \"${platform}\" = \"Linux\" ]; then \\\n").append("\t    ln -s i386/*.so . ; \\\n").append("\telif [ \"${platform}\" = \"SunOS\" ]; then \\\n").append("\t    ln -s solsparc/*.so . ; \\\n").append("\tfi;");
        substitute.setProperty("targets", targets.toString());
        Utilities.copyFileAndSubstitute(outFile, "/org/jdesktop/jdic/screensaver/autogen/resources/unix/Makefile.template", substitute, "[[", "]]", false);
    }

    private void generateUnixSource(File outDir, String filename, String jarArg, String classArg, String screensaverName, ArrayList options)
        throws IOException
    {
        ArrayList allParams = new ArrayList();
        for(int j = 0; j < options.size(); j++)
        {
            HackConfig.Option opt = (HackConfig.Option)options.get(j);
            HackConfig.Parameter params[] = opt.getParameters();
            for(int k = 0; k < params.length; k++)
                if(!allParams.contains(params[k]))
                    allParams.add(params[k]);

        }

        StringBuffer optionsBuffer = new StringBuffer();
        String kind[] = {
            "XrmoptionIsArg", "XrmoptionSepArg"
        };
        for(int j = 0; j < allParams.size(); j++)
        {
            HackConfig.Parameter p = (HackConfig.Parameter)allParams.get(j);
            if(!p.isStandardScreenhackParameter())
                optionsBuffer.append("    { \"-" + p.getName() + "\", " + "\"." + p.getName() + "\", " + kind[p.getType()] + ", 0 },\n");
        }

        File outFile = new File(outDir, filename + ".c");
        Properties substitute = new Properties();
        substitute.setProperty("name", screensaverName);
        substitute.setProperty("jar", jarArg);
        substitute.setProperty("class", classArg);
        substitute.setProperty("options", optionsBuffer.toString());
        Utilities.copyFileAndSubstitute(outFile, "/org/jdesktop/jdic/screensaver/autogen/resources/unix/saverbeans-unix.c.template", substitute, "[[", "]]", false);
    }

    private void generateWindowsExecutable(File outDir, String exeName, String jarArg, String classArg, String screensaverName, File configFile)
        throws IOException
    {
        StringBuffer configData = new StringBuffer();
        BufferedReader in = new BufferedReader(new FileReader(configFile));
        String line;
        while((line = in.readLine()) != null) 
        {
            configData.append(line);
            configData.append('\n');
        }
        in.close();
        Properties substitute = new Properties();
        substitute.setProperty("jar", jarArg);
        substitute.setProperty("name", screensaverName);
        substitute.setProperty("class", classArg.replace('.', '/'));
        substitute.setProperty("config", configData.toString());
        File outFile = new File(outDir, exeName + ".scr");
        Utilities.copyBinaryFileAndSubstitute(outFile, "/org/jdesktop/jdic/screensaver/autogen/resources/win32/saverbeans-win32.scr", substitute);
    }

    private File confDir;
    private File outDir;
    private ArrayList execs;
    private String os;
    private boolean jogl;
}
